// Copyright (C) 2005,  Lucian Constantin <struct_bylighting@yahoo.com>
// 
// This program is free software; you can redistribute it and/or 
// modify it under the terms of the GNU General Public License 
// as published by the Free Software Foundation; either 
// version 2 of the License, or (at your option) any later 
// version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///****************************************************************************
//** $Id: qt/qwerty.cpp   3.3.4   edited May 27 2003 $
//**
//** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
//**
//** This file is part of an example program for Qt.  This example
//** program may be used, distributed and modified without limitation.
//**
//*****************************************************************************/

#include "qwerty.h"


SyntaxHighlighter::SyntaxHighlighter(QTextEdit *textEdit) 
: QSyntaxHighlighter(textEdit) {
	return;
}

SyntaxHighlighter::~SyntaxHighlighter(void) {
	return;
}

int SyntaxHighlighter::highlightParagraph(const QString &text, 
								  int endStateOfLastPara) {

	int x = 0;
	QChar ch = text.at(x);
	int start = (endStateOfLastPara == 1)? 0:-1;
	while (!ch.isNull()) {
		if (ch == '<')
			start = x;
		if (ch == '>' && start != -1) {
			setFormat(start, x - start + 1, QColor(255, 25, 25));
			start = -1;
		}
		ch = text.at(++x);
		// skeep "<<" which usually appears in C/C++ text
		if (ch == '<' && text.at(x + 1) == '<') {
			ch = text.at(++x);
			ch = text.at(++x);
		}
	}

	if (start != -1) {
		setFormat(start, x - start, QColor(255, 0, 0));
		return 1;
	}
	return 0;
}

